//some vars we want to keep track of per script

m_ownerID = C_ENTITY_NONE;
m_damage = 1;

function OnInit() //run upon initialization
end

function OnPostInit() //run during the entity's first logic update
	//this:SetAnimFrame(0);
	//this:SetAnimPause(true);
	this:SetListenCollision(C_LISTEN_COLLISION_ALL_ENTITIES); //know when we bump into cans and things
	this:SetListenCollisionStatic(C_LISTEN_COLLISION_STATIC_ALL); //know when we bump into walls
	this:SetDensity(0.4); 
	this:SetType(C_TYPE_DAMAGE);
	this:SetName("");
	m_bExploding = false;
end

function OnKill() //run when removed
end

function SetSpeed( speed)
	this:SetMaxMovementSpeed(speed); //the maximum speed we can go
	this:SetDesiredSpeed(speed); //how fast we actually want to go
	this:SetAcceleration(speed); //how fast our bullet reaches top speed

end

function SetDirectionAndOwnerID(vDir, ownerID, damage)

	m_ownerID = ownerID;
	m_damage = damage;
	//GetWatchManager:Add(this, C_TIME_FOREVER);
	
	this:SetVisibilityNotifications(true); //OnGetVisible and OnLoseVisible will get called now
	
	//let's use a brain to control movement.  That way, later we can just
	//edit his visual profile and the bullet can have different animations for each
	//direction automatically if we want to do that.
	this:SetTurnSpeed(20); //instant
	this:SetMaxMovementSpeed(20); //the maximum speed we can go
	this:SetDesiredSpeed(20); //how fast we actually want to go
	this:SetAcceleration(20); //how fast our bullet reaches top speed
	this:SetPersistent(false); //don't save

	this:GetBrainManager():Add("StandardBase", "");
	this:GetBrainManager():SetStateByName("Walk");
	this:SetVectorFacingTarget(vDir);
	this:SetVectorFacing(vDir);
	this:SetEnableRotationPhysics(true);
	this:SetRotation(math.atan2(vDir.x, vDir.y) + math.pi);
	
	Schedule(3000, this:GetID(), "this:SetDeleteFlag(true)"); //kill ourselves in a bit
	
end

function OnLoseVisible() //we left the screen

  //we're off screen
  this:SetDeleteFlag(true);
end

function OnGetVisible() 
end

function Explode()
	
	 	//this:SetAnimPause(false);
		this:SetListenCollision(C_LISTEN_COLLISION_NONE); //don't get any more callbacks
		this:SetListenCollisionStatic(C_LISTEN_COLLISION_STATIC_NONE); //don't get any more callbacks
		this:GetBrainManager():SetStateByName("Idle"); //stop moving
		this:SetCollisionMode(C_COLLISION_MODE_NONE); //stop hitting anything actually
		
		//If we wanted to stop the bullet movement completely we could do this.  But we don't,
		//because we want it to keep pushing the can for a physics effect
		//this:Stop();

		//Note, another way we could have stopped movement, except without affecting angular movement:
		//this:AddForce( (this:GetVectorFacing()*-1) * this:GetLinearVelocity():Length());
		m_bExploding = true;
		//Schedule(400, this:GetID(), "this:SetDeleteFlag(true)"); //kill ourselves very soon
		this:SetDeleteFlag(true);
		
end

function OnCollisionStatic(normal, depth, materialID, ent) //return true/false to allow/disallow the collision

	//LogMsg("Hit a wall! Normal of collision is " .. tostring(normal));
		
		Explode();
	
	return true; //collision is valid
end


function OnCollision(normal, depth, materialID, ent) //return true/false to allow/disallow the collision

	if (ent:GetID() == m_ownerID) then
		//we shot it, don't let it kill us
		return false;
	end 
	
	if (m_ownerID != g_playerID and ent:GetType() == C_TYPE_ENEMY) then
		//don't let enemies hit other enemies
		return false;
	end
	//LogMsg("Hit by" .. ent:GetID());
	//LogMsg("Owner" .. m_ownerID);
	
	if (ent:GetType() != C_TYPE_DAMAGE) then
	 	//we'll, we're not touching the gun or another bullet, must be an enemy
		//LogMsg("We hit a " .. entType .. "!");
	 	//tell the thing we hit that they got damage so they can die or change color or whatever
		ent:RunFunctionIfExists("OnHit", m_damage);
		
		Explode();
		return true; //collision is valid
	end
	
	 
return false; //ignore collision
end

