
m_bDontSpawnAnotherOne = false;
m_hp = 5;


function OnInit() //run upon initialization
	this:SetType(C_TYPE_ENEMY);
	
	this:SetVisualProfile("~/robot/robot.xml", "robot8");
	this:LoadCollisionInfo("~/player.col");

	this:SetVisualState(C_VISUAL_STATE_IDLE);
	this:SetFacing(C_FACING_LEFT);
	this:SetSpriteByVisualStateAndFacing();
	this:SetIsCreature(true);
end

function OnPostInit() //run during the entity's first logic update

local col = this:GetBaseColor();
	
	
	if (this:GetLayerID() != this:GetMap():GetLayerManager():GetLayerIDByName("Hidden Data")
	or  m_bDontSpawnAnotherOne) then
	this:SetDensity(2);
	
		col:SetAlpha(255);
		this:SetPersistent(false);
		this:SetBaseColor(Color(255,255,255,255));
		this:SetLayerByName("Main");
		this:SetCollisionMode(C_COLLISION_MODE_ALL);

	else
	
		//just make a copy of ourself and hide.  The copy will not be saved with
		//the map, we will, unchanged.	
		local ent = this:Clone(this:GetMap(), this:GetPos());
		ent:RunFunction("OnStartup");
		col:SetAlpha(100);
		this:SetCollisionMode(C_COLLISION_MODE_NONE);
	end
	
		this:SetBaseColor(col);
	
end

function OnStartup()
	
	m_bDontSpawnAnotherOne = true;
	
end

function OnKill() //run when removed
end

function OnHit(damage) 
	
		if (m_bDontSpawnAnotherOne == false) then
		return false;  //not ready for battle yet, this could happen if a bullet hit him offscreen
	end

	if (m_hp <= 0) then return; end; //already dead
	m_hp = m_hp - damage;
	
	if (m_hp <= 0) then
		//we died
		//LogMsg("Hit ", tostring(this:GetID()) .. " who has " .. tostring(m_hp));
			this:Stop();
			this:SetVisualState(C_VISUAL_STATE_DIE);
			this:SetSpriteByVisualStateAndFacing();
			this:SetCollisionMode(C_COLLISION_MODE_NONE);
			this:PlaySoundPositioned("audio/die.ogg");
	else
				this:PlaySoundPositioned("audio/glance.ogg");

		//show damage effect?
	//	if (this:GetBrainManager():GetBrainByName("ColorFlash") != nil) then
			this:GetBrainManager():Add("ColorFlash", "pulse_rate=110;r=100;g=100;b=100;remove_brain_by_pulses=1");
		//	end;
	
	end
end


