
m_bDontSpawnAnotherOne = false;
m_hp = 5;
m_eyesight = 800;
m_thinkDelay = 750;

function OnInit() //run upon initialization
	this:SetType(C_TYPE_ENEMY);
	this:SetVisualProfile("~/turret.xml", "turret");
	this:LoadCollisionInfo("~/turret.col");

	this:SetVisualState(C_VISUAL_STATE_IDLE);
	this:SetFacing(C_FACING_LEFT);
	this:SetSpriteByVisualStateAndFacing();

end

function OnPostInit() //run during the entity's first logic update

local col = this:GetBaseColor();
	
	
	if (this:GetLayerID() != this:GetMap():GetLayerManager():GetLayerIDByName("Hidden Data")
	or  m_bDontSpawnAnotherOne) then
	this:SetDensity(1);
	
		col:SetAlpha(255);
		this:SetPersistent(false);
		this:SetBaseColor(Color(255,255,255,255));
		this:SetLayerByName("Main");
		this:SetCollisionMode(C_COLLISION_MODE_ALL);

	else
	
		//just make a copy of ourself and hide.  The copy will not be saved with
		//the map, we will, unchanged.	
		local ent = this:Clone(this:GetMap(), this:GetPos());
		ent:RunFunction("OnStartup");
		col:SetAlpha(100);
		this:SetCollisionMode(C_COLLISION_MODE_NONE);
	end
	
		this:SetBaseColor(col);
	
end

function OnStartup()
	
		m_bDontSpawnAnotherOne = true;
	
		this:GetBrainManager():Add("StandardBase","");
		this:GetBrainManager():SetStateByName("Idle");
		this:SetListenCollision(C_LISTEN_COLLISION_PLAYER_ONLY);
	
			this:SetIsCreature(true);
	
		Schedule(m_thinkDelay, this:GetID(), "OnLookAround()");
		
		if (this:Data():Exists("hp")) then
			//read our HP from data entered in the editor
			m_hp = this:Data():GetNum("hp");
		end
		
			if (this:Data():Exists("eyesight")) then
			//read our HP from data entered in the editor
			m_eyesight = this:Data():GetNum("eyesight");
		end
		
		if (this:Data():Exists("thinkdelay")) then
			//read our HP from data entered in the editor
			m_thinkDelay = this:Data():GetNum("thinkdelay");
		end
end


function OnLookAround()
	
	if (m_hp <= 0) then return; end; //already dead

	if (this:IsCloseToEntity(GetPlayer, m_eyesight))then
		if ( this:HasLineOfSightToPosition(GetPlayer:GetPos(), true) ) then
		
			if (this:Data():Exists("stationary") == false) then
	//chase him?
			this:GetGoalManager():RemoveAllSubgoals();
			this:GetGoalManager():PushMoveToPosition(GetPlayer:GetPos());
			end
			
			//shoot him?
			if (this:Data():Exists("shooting")) then
	
			local vDir = this:GetVectorToEntity(GetPlayer);
			
			local offsetDistance = 40;
			local vSpawnPosition = this:GetPos() + (vDir * offsetDistance);

	
			local entBullet = GetEntityByName("bullet_template_round"):Clone(this:GetMap(), vSpawnPosition);
			entBullet:RunFunction("SetDirectionAndOwnerID", vDir, this:GetID(), 1);
			entBullet:RunFunction("SetSpeed", 3);
			this:PlaySoundPositioned("audio/enemy_shoot.ogg");
	
		end
		
			
		end
	end
	
	Schedule(m_thinkDelay, this:GetID(), "OnLookAround()");
	
end

function OnKill() //run when removed
end

function OnHit(damage) 
	if (m_bDontSpawnAnotherOne == false) then
		return false;  //not ready for battle yet, this could happen if a bullet hit him offscreen
	end
	if (m_hp <= 0) then return; end; //already dead
	m_hp = m_hp - damage;
	
	if (m_hp <= 0) then
		//we died
		//LogMsg("Hit ", tostring(this:GetID()) .. " who has " .. tostring(m_hp));
			this:GetGoalManager():RemoveAllSubgoals();
	
			this:Stop();
			this:GetBrainManager():SetStateByName("Die");
			this:SetCollisionMode(C_COLLISION_MODE_NONE);
			this:PlaySoundPositioned("audio/die.ogg");
	else
	
		//show damage effect?
	//	if (this:GetBrainManager():GetBrainByName("ColorFlash") != nil) then
			this:GetBrainManager():Add("ColorFlash", "pulse_rate=110;r=100;g=100;b=100;remove_brain_by_pulses=1");
			this:PlaySoundPositioned("audio/glance.ogg");

		//	end;
	
	end
end


function OnCollision(normal, depth, materialID, ent) //return true/false to allow/disallow the collision

		//if this is called, we must have hit the player, which should be passed in as ent.

  	//let the player know by calling his OnDamage.  Send extra info just in case he wants it.
  	ent:RunFunction("OnDamage", normal, depth, nil, 5, 0, this);

	return true; //true allows the physics of the collision to happen, so the dragon will
	//push the player.

end